// Copyright (c) 2023, the R8 project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

package com.android.tools.r8.ir.desugar.annotations.version2;

import static com.android.tools.r8.ir.desugar.annotations.CovariantReturnTypeAnnotationTransformerTest.CRT_BINARY_NAME;
import static com.android.tools.r8.ir.desugar.annotations.CovariantReturnTypeAnnotationTransformerTest.PACKAGE_NAME;

import org.objectweb.asm.AnnotationVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.Type;

// Generated by running tools/asmifier.py on build/classes/test/com/android/tools/r8/ir/desugar/
// annotations/version2/E.class, removing the subpackage "version2" from all class names, and
// manually changing the name of the CovariantReturnType annotation to
// "Ldalvik/annotation/codegen/CovariantReturnType;".
public class EDump implements Opcodes {
  public static byte[] dump() throws Exception {

    ClassWriter cw = new ClassWriter(0);
    MethodVisitor mv;
    AnnotationVisitor av0;

    cw.visit(
        V1_8,
        ACC_PUBLIC | ACC_SUPER | ACC_ABSTRACT,
        PACKAGE_NAME + "/E",
        null,
        PACKAGE_NAME + "/D",
        null);

    {
      mv = cw.visitMethod(ACC_PUBLIC, "<init>", "()V", null, null);
      mv.visitCode();
      mv.visitVarInsn(ALOAD, 0);
      mv.visitMethodInsn(INVOKESPECIAL, PACKAGE_NAME + "/D", "<init>", "()V", false);
      mv.visitInsn(RETURN);
      mv.visitMaxs(1, 1);
      mv.visitEnd();
    }
    {
      mv =
          cw.visitMethod(
              ACC_PUBLIC | ACC_ABSTRACT, "method", "()L" + PACKAGE_NAME + "/D;", null, null);
      {
        av0 = mv.visitAnnotation("L" + CRT_BINARY_NAME + ";", false);
        av0.visit("returnType", Type.getType("L" + PACKAGE_NAME + "/E;"));
        av0.visit("presentAfter", new Integer(25));
        av0.visitEnd();
      }
      mv.visitEnd();
    }
    cw.visitEnd();

    return cw.toByteArray();
  }
}
